#pragma once

#include <exception>

#include "manager.h"

namespace cpplogging
{

    /* manager::consumer_wrapper */

    manager::consumer_wrapper
        ::consumer_wrapper(consumer& p_consumer)
            : _consumer (p_consumer)
            , _storage  (nullptr)
            { }

    manager::consumer_wrapper
        ::consumer_wrapper(consumer_ptr_u&& p_consumer)
            : _consumer (*p_consumer)
            , _storage  (std::move(p_consumer))
            { }

    bool manager::consumer_wrapper
        ::operator<(const consumer_wrapper& other) const
        { return &_consumer < &other._consumer; }

    consumer* manager::consumer_wrapper
        ::operator->()
        { return &_consumer; }

    const consumer* manager::consumer_wrapper
        ::operator->() const
        { return &_consumer; }

    consumer& manager::consumer_wrapper
        ::operator*()
        { return _consumer; }

    const consumer& manager::consumer_wrapper
        ::operator*() const
        { return _consumer; }

}
