#pragma once

#include "matcher.h"

namespace cpplogging
{

    /**
     * @brief This matcher matches any logger and any consumer.
     */
    struct matcher_all
        : public matcher
    {
        /**
         * @brief Check if the passed logger match this matcher.
         *
         * @param[in] logger    Logger to check.
         *
         * @retval true         If the logger matches.
         * @retval false        If the logger does not match.
         */
        bool match(const logger& logger) const override;

        /**
         * @brief Check if the passed consumer match this matcher.
         *
         * @param[in] consumer  Consumer to check.
         *
         * @retval true         If the consumer matches.
         * @retval false        If the consumer does not match.
         */
        bool match(const consumer& consumer) const override;
    };

}
