#pragma once

#include "matcher.h"

namespace cpplogging
{

    /**
     * @brief This matcher does only match the default logger.
     */
    struct matcher_default_logger
        : public matcher
    {
    private:
        logger& _default; //!< the default logger

    public:
        using matcher::match;

        /**
         * @brief Constructor.
         */
        matcher_default_logger();

        /**
         * @brief Check if the passed logger match this matcher.
         *
         * @param[in] logger    Logger to check.
         *
         * @retval true         If the logger matches.
         * @retval false        If the logger does not match.
         */
        bool match(const logger& logger) const override;
    };

}
